# -*- coding: utf-8 -*-
"""
Created on Tue Aug 22 17:22:24 2023
This example scripts reads semd files generated by elastic-acoustic modeling
software SPECFEM2D and converts it to sg2 format which can by read by 
proprietary seismic processing software VISTA (Schlumberger)

For model stability the semd files are strongly oversampled so they are
downsampled before conversion.

For a quick check check, the data is displayed with imshow.

@author: nieboer
"""

#short imports due to __init__.py file
from gpmt import read_semd, resample, export_sgy
import matplotlib.pyplot as plt
from pathlib import Path 
from re import findall
import tkinter.filedialog, tkinter.simpledialog
import tkinter as tk
root = tk.Tk().withdraw()

main_directory = Path(r'\\wsl.localhost\Ubuntu\home\rlnd\projects\DiggerDAS\hole1')
sub_directories = [entry for entry in main_directory.iterdir() if entry.is_dir()]


for directory in sub_directories:
    directory = directory/"OUTPUT_FILES"
    print(directory)
    
    extension = ".semp"
    file_list = [file for file in directory.iterdir() if file.is_file() and file.name.endswith(extension)]
    
        
    # file_list= tk.filedialog.askopenfilenames(filetypes = (
    #     ("SPECFEM XZ component","*Z.semd"),
    #     ("SPECFEM XX component","*X.semd"),
    #     ("all files","*.*")))
    
    out_folder = Path(file_list[0]).parents[2]
    shot_name = Path(file_list[0]).parents[1].name
    
    #%%READ SPECFEM FILES TO GPMT FORMAT
    
    data, fs, t_start = read_semd(file_list, verbose=True)
    dx = 0.5 #m receiver spacing
    shotpoint_interval = 0.5 #m

    #%%RESAMPLE, keep ~5x nyquist, max frequency to be retrieved 150 Hzd
    
    fs_resample = 4000 #Hz
    data_resample = resample(data, fs, fs_resample)
    
    #%% PLOT FOR QC
    
    # cmap = "RdBu"
    cmap = "Greys"
    plt.ioff() 
    
    extent = [0, data_resample.shape[1]*dx, (data_resample.shape[0]/fs_resample) + t_start, t_start]
    plt.imshow(data_resample, aspect='auto', extent=extent,  cmap=cmap)
    plt.title("Seismic shot record (sampling rate fs={})".format(round(fs_resample,1)))
    plt.xlabel("Receiver position (m)")
    plt.ylabel("Two-way travel time (s)")
    
    out_fig =(out_folder/shot_name).with_suffix(".png")
    plt.savefig(out_fig)
    
    #%%
    #EXPORT GPMT FORMAT TO SG2 TO BE USED IN VISTA
    shot_number = int(findall(r'\d+', shot_name)[0])
    
    out_sgy =(out_folder/shot_name).with_suffix(".sgy")
    export_sgy(data_resample, fs_resample, dx, shot_number, shotpoint_interval, out_sgy)
    
    
